jQuery(document).ready(() => {
    // Wait till Document is usable
    jQuery("#submit_prompt").submit(function (e) {
        e.preventDefault();
        jQuery("#submit_button").prop('disabled', true);

        let prompt = jQuery("#prompt").val();
        if (prompt.length > 0) {
            jQuery("#chat").append("<p>User: " + prompt + "</p>");
            jQuery.ajax({
                type: 'POST',
                dataType: 'json',
                url: sat_ai_vars.AJAXUrl,
                data: {
                    action: 'sat_ai_create_ChatCompletion',
                    prompt: prompt,
                    nonce: sat_ai_vars.nonce
                },
                success: function (data, textStatus, XMLHttpRequest) {
                    if (data.result) {
                        data.answers.forEach((answer) => {
                            jQuery("#chat").append("<p>GPT: " + answer.message.value + "</p>");
                        });
                    } else {
                        jQuery("#chat").append("<p>" + wp.i18n.__("Error: Please try in a few minutes again.", "sat-ai") + "</p>");
                    } 
                    let session_id = data.session_id;
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    jQuery("#chat").append("<p>" + wp.i18n.__("Error: Your request could not be processed. Please try in a few minutes again.", "sat-ai") + "</p>");
                },
                complete: function (XMLHttpRequest, status) {
                    jQuery("#submit_button").prop('disabled', false);
                }
            });
        } else {
            jQuery("#submit_button").prop('disabled', false);
        }
    });

    jQuery("#sat_ai_tool_eventname").change(function(event) {
        document.getElementById("event_name").innerHTML = event.target.value;
    })
});

function sat_changeHandler(radio) {
    if(radio.value == "On"){
        document.getElementById("openai_receiver_mail").required = true;
    }else{
        document.getElementById("openai_receiver_mail").required = false;
    }
}