jQuery(document).ready(() => {
    let chats = document.getElementsByClassName('sat-chat');
    for (let index = 0; index < chats.length; index++) {
        chats[index].onclick = get_chat_history;
    }
});
let loading = false;

function get_chat_history(element) {
    // Prepare
    if (loading) {
        return;
    }
    loading = true;
    let old_opend = document.getElementsByClassName('sat-chat-open')[0];
    if (old_opend == this) {
        loading = false;
        return; //skip if already opened
    }
    if (old_opend != undefined) {
        old_opend.classList.remove('sat-chat-open');
    }
    this.classList.add('sat-chat-open');

    let chat_id = this.id.split('-').pop();

    let delete_id = jQuery("#id");
    delete_id.val(chat_id);
    

    let tbody = document.querySelector("table.sat-chat-verlauf > tbody");
    tbody.innerHTML = ""; // resets View
    // DO AJAX
    jQuery.ajax({
        type: 'POST',
        dataType: 'json',
        url: sat_ai_vars.AJAXUrl,
        data: {
            action: 'sat_ai_get_Chat',
            chatID: chat_id,
            nonce: sat_ai_vars.nonce
        },
        success: function (data, textStatus, XMLHttpRequest) {
            let result = data.data;
            for (let index = 0; index < result.length; index++) {
                let row = tbody.insertRow(index);
                let cell1 = row.insertCell(0);
                let cell2 = row.insertCell(1);
                let cell3 = row.insertCell(2);
                let cell4 = row.insertCell(3);
                cell1.innerHTML = result[index].role;
                cell2.innerHTML = result[index].message;
                cell3.innerHTML = result[index].tokens;
                cell4.innerHTML = new Date(result[index].message_time).toLocaleDateString() + " " + new Date(result[index].message_time).toLocaleTimeString();
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            // console.log(textStatus);
            // console.log(errorThrown);
            // console.log(XMLHttpRequest);
            // Fehlernachricht?
        },
        complete: function (XMLHttpRequest, status) {
            loading = false;
        }
    });
}