<?php
// Functions for AJAX
function sat_ai_create_ChatCompletion()
{
    if (!isset($_POST) || empty($_POST)) {
        die;
    }

    if (!wp_verify_nonce($_POST['nonce'], 'ajax-nonce')) {
        die(esc_html(__('You are not authorized!', "sat-ai")));
    }

    if (!empty($_POST['password'])) {
        echo wp_json_encode(array('result' => false, "answer" => __("I can not help you.", "sat-ai")));
        die();
    }
    if (!empty($_POST['session_id'])) {
        session_id($_POST['session_id']);
    }

    $result = array();
    $prompt = isset($_POST['prompt']) ? sanitize_text_field($_POST["prompt"]) : ""; // Strips all tags, % encoded characters, invalid utf8, singl < to html-entity
    // $pageID = isset($_POST['page']) ? intval($_POST['page']) : 0;

    // Exit early
    if ($prompt == "") {
        $result["result"] = false;
        echo wp_json_encode($result);
        wp_die();
    }

    $result["result"] = true;
    $result["answers"] = array();
    $result["raise_events"] = array();
    // get_answer

    // Case which returns possibly an Array of Messages
    $answer_obj = sat_ai_doAssistantChat($prompt);
    if ($answer_obj == false) {
        $result["result"] = false;
    } else {
        $result["answers"] = $answer_obj["messages"];
        $result["raise_events"] = $answer_obj["events"];
    }


    $result["session_id"] = session_id();

    echo wp_json_encode($result);
    wp_die();
}

function sat_ai_get_chatHistory()
{
    if (!isset($_POST)) {
        die;
    }
    if (!wp_verify_nonce($_POST['nonce'], 'ajax-nonce')) {
        die(esc_html(__('You are not authorized!', "sat-ai")));
    }

    sat_ai_start_session();

    echo wp_json_encode($_SESSION["sat_ai_all_messages"]);


    wp_die();
}

function sat_ai_get_Chat()
{
    if (!isset($_POST)) {
        die;
    }
    if (!wp_verify_nonce($_POST['nonce'], 'ajax-nonce')) {
        die(esc_html(__('You are not authorized!', "sat-ai")));
    }
    if (!current_user_can('manage_options')) {
        wp_die(esc_html(__('Insufficent permission!', 'sat-ai')));
    }

    $result = array();

    $id = isset($_POST['chatID']) ? intval(sanitize_textarea_field($_POST["chatID"])) : 0;
    if ($id != 0) {
        $chat = sat_ai_get_Chat_Verlauf($id);
        $result['result'] = true;
        $result['data'] = $chat;
    } else {
        $result['result'] = false;
    }

    echo wp_json_encode($result);
    wp_die();
}
