<?php
$sat_ai_dsgvo_setting = get_option("set_openai_dsgvo_behaviour");
$sat_openai_key = get_option("sat_openai_key");
$sat_ai_chathistory_setting = get_option("sat_openai_chathistory_behaviour");
$obscured_openai_key = sat_ai_obscure_sensitive_strings($sat_openai_key);
$obscured_openai_assistant_id = sat_ai_obscure_sensitive_strings($assistant_id);
?>

<form method="post">
    <h3><?php esc_html_e("Insert your OpenAI API-Key", "sat-ai") ?></h3>
    <input type="text" id="openai_key" name="openai_key" placeholder="sk-...." value="<?php echo esc_html($obscured_openai_key) ?>" required />
    <h3><?php esc_html_e("Insert your Assistant ID", "sat-ai") ?></h3>
    <input type="text" id="gpt_assistant" name="gpt_assistant" placeholder="asst_....." value="<?php echo esc_html($obscured_openai_assistant_id) ?>" required />
    <br />
    <h3><?php esc_html_e("Chathistory", "sat-ai") ?></h3>
    <p><?php esc_html_e("The following setting defines if the chat history should be saved in the WordPress database.", "sat-ai")?></p>
    <input type="radio" id="sat-chathistory-off" name="sat_chat_history_setting" value="Off" title="<?php esc_html_e("Deactivates local saving of the chat history in the database", "sat-ai") ?>" <?php echo esc_html($sat_ai_chathistory_setting == 0 ? "checked" : "") ?> required />
    <label for="sat-chathistory-off" title="<?php esc_html_e("Deactivates local saving of the chat history", "sat-ai") ?>"><?php echo esc_html_e("Deactivate local saving", "sat-ai") ?></label>
    <br />
    <input type="radio" id="sat-chathistory-on" name="sat_chat_history_setting" value="On" title="<?php esc_html_e("Activates local saving of the chat history in the database", "sat-ai") ?>" <?php echo esc_html($sat_ai_chathistory_setting == 1 ? "checked" : "") ?> required />
    <label for="sat-chathistory-on" title="<?php esc_html_e("Activates local saving of the chat history", "sat-ai") ?>"><?php echo esc_html_e("Activate local saving", "sat-ai") ?></label>
    <h3><?php esc_html_e("Manual mode", "sat-ai") ?></h3>
    <input type="radio" id="sat-off" name="sat_dsgvo_setting" value="Off" title="<?php esc_html_e("The required JavaScript File will be loaded on siteload.", "sat-ai") ?>" <?php echo esc_html($sat_ai_dsgvo_setting == 0 ? "checked" : "") ?> required />
    <label for="sat-off" title="<?php esc_html_e("The required JavaScript File will be autoloaded on siteload.", "sat-ai") ?>"><?php echo esc_html_e("Autoload required files", "sat-ai") ?></label>
    <br />
    <input type="radio" id="sat-on" name="sat_dsgvo_setting" value="On" title="<?php esc_html_e("The required JavaScript File will not be autoloaded on siteload. It needs to be loaded by a third party e.g. through your consent management tool.", "sat-ai") ?>" <?php echo esc_html($sat_ai_dsgvo_setting == 1 ? "checked" : "") ?> required />
    <label for="sat-on" title="<?php esc_html_e("The required JavaScript File will not be autoloaded on siteload. It needs to be loaded by a third party e.g. through your consent management tool.", "sat-ai") ?>"><?php esc_html_e("Required files need to be load through a third party e.g through your consent management tool", "sat-ai") ?></label>
    <br />
    <p><?php esc_html_e("Paths to the required files, which need to be loaded:", "sat-ai") ?><br />
        <?php echo esc_url(SAT_AI_PLUGIN_URL . "public/js/sat_ai.js"); ?>
    </p>
    <?php wp_nonce_field('sat-ai-settings'); ?>
    <input type="hidden" id="task" name="task" value="set_api_settings" />
    <input type="submit" class="button" id="submit_setting" name="submit_setting" value="<?php echo esc_html_x("Save", "button", "sat-ai") ?>" />
</form>