<?php
$ai_modell = get_option("sat_openai_modell");
// $models = sat_ai_get_models();
// if (!$models) {
//     $models = (object) array();
//     $models->data = (object) array();
//     // echo $models->data;
// }
$roles = get_sat_openai_roles(); // return either empty array or a set of [id, title]
// $ai_role = get_option("sat_openai_role");
$first_message = stripslashes(get_option("sat_chatbot_first_message", ""));
$ai_receiver_mail = get_option("sat_openai_receiver_mail");
$ai_chat_limit = get_option("sat_openai_chat_limit");
$last_message = stripslashes(get_option("sat_chat_bot_last_message", ""));
// in a future update tools will be differently stored and collect e.g custom posttype with custom meta_fields e.g event_name, which can used to call upon
$sat_ai_tool = get_option("sat_ai_tool");
?>

<form method="post">
    <!-- Chatbot Model -->
    <h3><?php esc_html_e("Select the GPT model which your Chatbot should use", "sat-ai") ?></h3>
    <label for="gpt_modell"><?php echo esc_html_x("GPT-Model", "field-name", "sat-ai") ?></label>
    <br>
    <select id="gpt_modell" name="gpt_modell" required>
        <option value="0" disabled<?php echo esc_html($ai_modell == ""  || $ai_modell == 0 || $ai_modell === false ? " selected" : "") ?>><?php esc_html_e("No model selected", "sat-ai") ?></option>
        <?php
        // TODO - if Published allow all models?
        $allowed_models = array(
            "gpt-4",
            "gpt-4o",
            "gpt-4-16k",
            "gpt-4-turbo",
            "gpt-4-turbo-preview",
            // "gpt-4-vision",
            // "gpt-4-vision-preview",
            "gpt-4-32k",
            "gpt-4-1106-preview",
            "gpt-3.5-turbo",
            "gpt-3.5-turbo-16k",
            "gpt-3.5-turbo-instruct",
            // "davinci-002",
            // "babbage-002",
        );

        foreach ($models->data as $result) {
            // restricted to GPT 4 & GPT3 Turbo

            if (in_array($result->id, $allowed_models)) {
        ?>
                <option value="<?php echo esc_html($result->id) ?>" <?php echo esc_html($ai_modell == $result->id ? ' selected' : '') ?>><?php echo esc_html($result->id) ?></option>
        <?php
            }
        }
        ?>
    </select>
    <br>
    <!-- Chatbot Role -->
    <h3><?php esc_html_e("Select the Chatbot role to use", "sat-ai") ?></h3>
    <select id="sat_chatbot_rolle" name="sat_chatbot_rolle" required>
        <!-- Der Fall "keine Roll" darf von Nutzer nicht erreicht werden -->
        <option value="0" disabled<?php echo esc_html($ai_role == 0 || $ai_role === false ? ' selected' : '') ?>><?php esc_html_e("No role selected", "sat-ai") ?></option>
        <?php
        foreach ($roles as $role) {
        ?>
            <option value="<?php echo esc_html($role["id"]) ?>" <?php echo esc_html($ai_role == $role["id"] ? ' selected' : '') ?>><?php echo esc_html($role["title"]) ?></option>
        <?php
        }
        ?>
    </select>
    <br />
    <!-- Chatbot Start and End Text behaviour -->
    <h3><?php esc_html_e("Define the opening message", "sat-ai") ?></h3>
    <p><?php esc_html_e("This message is always sent first and should be used to motivate users to use the chatbot.", "sat-ai") ?></p>
    <textarea placeholder="<?php esc_html_e("How can I help you?", "sat-ai") ?>" title="<?php esc_html_e("Define the opening message, it will not be attached to the context.", "sat-ai") ?>" style="width: 100%; height: 25vh;" name="chatbot_first_message" id="chatbot_first_message" required><?php echo esc_html($first_message ? $first_message : "") ?></textarea>
    <br />
    <h3><?php esc_html_e("Set the user request limit", "sat-ai") ?></h3>
    <label for="chatbot_chat_limit"><?php esc_html_e("Set how many requests a user is allowed to send until the session is aborted by the plugin (0 means unlimited).", "sat-ai") ?></label>
    <br />
    <input type="number" placeholder="e.g. 20" title="<?php esc_html_e("Defines how many request a user is allowed to send.", "sat-ai") ?>" name="chatbot_chat_limit" id="chatbot_chat_limit" min="0" value="<?php echo esc_html($ai_chat_limit); ?>" required />
    <br />
    <label for="chatbot_last_message"><?php esc_html_e("Define the message, which the chatbot should send if the user reached his request limit.", "sat-ai") ?></label>
    <textarea placeholder="<?php echo esc_html_x("You have reached your request limit. For further information about our services please contact us via phone 01234567 or E-Mail: a@example.de", "placeholde", "sat-ai") ?>" title="<?php esc_html_e("Define the message, which the chatbot should send if the user reached its request limit.", "sat-ai") ?>" style="width: 100%; height: 25vh;" name="chatbot_last_message" id="chatbot_last_message" required><?php echo esc_html($last_message ? $last_message : "") ?></textarea>
    <br />
    <br />
    <!-- Tools and E-Mail -->
    <hr style="border-color: darkgray;">
    <h2><?php esc_html_e("Advanced Settings", "sat-ai") ?></h2>
    <h3><?php esc_html_e("Contact function", "sat-ai") ?></h3>
    <p><?php echo nl2br(esc_html__("When enabled, a contact request will be sent to the specified e-mail address. The users is required to enter an e-mail address and telephone number if they want to send a message. Any additional fields such as name and subject must be defined in the role.
    When disabled, this feature is turned off, and no contact requests will be sent. 
    To finetune the trigger point and when a contact request should be sent, we recommend you to define your usecases in the chatbot role.", "sat-ai")) ?></p>
    <input type="radio" name="sat_ai_tool" id="sat_ai_tool_on" value="On" <?php echo esc_html($sat_ai_tool == 1 ? "checked" : "") ?> onchange="sat_changeHandler(this)">
    <label for="sat_ai_tool_on" title="<?php esc_html_e("Enables the contact function", "sat-ai") ?>"><?php esc_html_e("Enable", "sat-ai") ?></label>
    <br />
    <input type="radio" name="sat_ai_tool" id="sat_ai_tool_off" value="Off" <?php echo esc_html($sat_ai_tool == 0 ? "checked" : "") ?> onchange="sat_changeHandler(this)">
    <label for="sat_ai_tool_off" title="<?php esc_html_e("Disables the contact function", "sat-ai") ?>"><?php esc_html_e("Disable", "sat-ai") ?></label>
    <br />
    <label for="sat-example-code"><?php esc_html_e("Example JS-Code to attach 'Matomo Goal Tracking' to the contact request", "sat-ai") ?></label>
    <pre id="sat-example-code">
&lt;script&gt;
    document.addEventListener("sat_ai_contact", (event) =&gt; {
        // Example implementation of Matomo Goal tracking.
        var _paq = window._paq = window._paq || [];
        _paq.push(['trackGoal', X]);    // X needs to be changed to the Goal ID which it is assosiated with
    });
&lt;/script&gt;
    </pre>
    <p><?php esc_html_e("The contact request will be sent to the following e-mail address:", "sat-ai") ?></p>
    <input type="email" id="openai_receiver_mail" title="<?php esc_html_e("Enter the e-mail address to which the contact request should be sent.", "sat-ai") ?>" name="openai_receiver_mail" placeholder="examble@example.com" value="<?php echo esc_html($ai_receiver_mail ? $ai_receiver_mail : "") ?>" <?php echo esc_html($sat_ai_tool == 1 ? "required" : "") ?> />
    <br />
    <br />
    <?php wp_nonce_field('sat-ai-settings'); ?>
    <input type="hidden" id="task" name="task" value="set_openai_general_setting" />
    <input type="submit" class="button" id="submit_setting" name="submit_setting" value="<?php echo esc_html_x("Save", "button", "sat-ai") ?>" />
</form>